// Copyright 1999-2018 - Universit de Strasbourg/CNRS
// The Aladin Desktop program is developped by the Centre de Donnes
// astronomiques de Strasbourgs (CDS).
// The Aladin Desktop program is distributed under the terms
// of the GNU General Public License version 3.
//
//This file is part of Aladin.
//
//    Aladin Desktop is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, version 3 of the License.
//
//    Aladin Desktop is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    The GNU General Public License is available in COPYING file
//    along with Aladin.
//

package cds.aladin.prop;

import java.util.Vector;

/** Interface pour un objet qui peut fournir une liste de proprits (Prop)
 * @date dc 2011 - cration
 * @author Pierre Fernique [CDS]
 */
public interface Propable {
   
   /** @return true si l'objet a des proprits qui lui sont associes */
   public boolean hasProp();
   
   /** @return fournit la liste des proprits */
   public Vector<Prop> getProp();
}


